Package: org.apache.groovy.antlr

## [Java] Class GroovydocVisitor

- org.apache.groovy.antlr.GroovydocVisitor

-     public class GroovydocVisitor
      extends ClassCodeVisitorSupport

  A visitor which collects Groovydoc information.

- - ### Constructor Summary

    Constructors
    Constructor and description
    `GroovydocVisitor(SourceUnit unit, String packagePath, List<LinkArgument> links)` Creates a visitor that collects Groovydoc for classes in the given package.
    `GroovydocVisitor(SourceUnit unit, String packagePath, List<LinkArgument> links, Properties properties)` Creates a visitor that collects Groovydoc for classes in the given package, using the supplied generation `properties`.

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public Map<String, GroovyClassDoc>` | `getGroovyClassDocs()` Returns the collected class documentation, keyed by full path name.
    `` | `protected SourceUnit` | `getSourceUnit()` Provides access to the SourceUnit for error reporting during visitation. Implementations must override this method. Returns: the source unit for this visitor
    `` | `public void` | `visitClass(ClassNode node)` Visits a ClassNode, processing its annotations, package, imports, contents, and object initializers. Parameters: `node` - the class node to visit
    `` | `public void` | `visitConstructor(ConstructorNode node)` Visits a ConstructorNode, processing its annotations, parameter annotations, and code block. Parameters: `node` - the constructor node to visit
    `` | `public void` | `visitDeclarationExpression(DeclarationExpression expression)` Visits a DeclarationExpression with annotation processing, traversing expression annotations before delegating to parent traversal. Parameters: `expression` - the declaration expression to visit
    `` | `public void` | `visitField(FieldNode node)` Visits a FieldNode, processing its annotations and initial value expression if present. Parameters: `node` - the field node to visit
    `` | `public void` | `visitMethod(MethodNode node)` Visits a MethodNode, processing its annotations, parameter annotations, and code block. Parameters: `node` - the method node to visit
    `` | `public void` | `visitProperty(PropertyNode node)` Visits a PropertyNode, processing its annotations, initial value expression, and getter/setter blocks if present. Parameters: `node` - the property node to visit

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class ClassCodeVisitorSupport` | `addError, getSourceUnit, visitAnnotation, visitAnnotations, visitAnnotations, visitAssertStatement, visitBlockStatement, visitBreakStatement, visitCaseStatement, visitCatchStatement, visitClass, visitClassCodeContainer, visitClosureExpression, visitConstructor, visitConstructorOrMethod, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitExpressionStatement, visitField, visitForLoop, visitIfElse, visitImports, visitMethod, visitObjectInitializerStatements, visitPackage, visitProperty, visitReturnStatement, visitStatement, visitStatementAnnotations, visitSwitch, visitSynchronizedStatement, visitThrowStatement, visitTryCatchFinally, visitWhileLoop`
    `class CodeVisitorSupport` | `afterSwitchCaseStatementsVisited, afterSwitchConditionExpressionVisited, visitArgumentlistExpression, visitArrayExpression, visitAssertStatement, visitAttributeExpression, visitBinaryExpression, visitBitwiseNegationExpression, visitBlockStatement, visitBooleanExpression, visitBreakStatement, visitBytecodeExpression, visitCaseStatement, visitCastExpression, visitCatchStatement, visitClassExpression, visitClosureExpression, visitClosureListExpression, visitConstantExpression, visitConstructorCallExpression, visitContinueStatement, visitDeclarationExpression, visitDoWhileLoop, visitEmptyStatement, visitExpressionStatement, visitFieldExpression, visitForLoop, visitGStringExpression, visitIfElse, visitLambdaExpression, visitListExpression, visitMapEntryExpression, visitMapExpression, visitMethodCallExpression, visitMethodPointerExpression, visitMethodReferenceExpression, visitNotExpression, visitPostfixExpression, visitPrefixExpression, visitPropertyExpression, visitRangeExpression, visitReturnStatement, visitShortTernaryExpression, visitSpreadExpression, visitSpreadMapExpression, visitStaticMethodCallExpression, visitSwitch, visitSynchronizedStatement, visitTernaryExpression, visitThrowStatement, visitTryCatchFinally, visitTupleExpression, visitUnaryMinusExpression, visitUnaryPlusExpression, visitVariableExpression, visitWhileLoop`

- - ### Constructor Detail

    - #### public GroovydocVisitor(SourceUnit unit, String packagePath, List<LinkArgument> links)

      Creates a visitor that collects Groovydoc for classes in the given package.

    - #### public GroovydocVisitor(SourceUnit unit, String packagePath, List<LinkArgument> links, Properties properties)

      Creates a visitor that collects Groovydoc for classes in the given package, using the supplied generation `properties`.

  - ### Method Detail

    - #### public Map<String, GroovyClassDoc> getGroovyClassDocs()

      Returns the collected class documentation, keyed by full path name.

    - #### protected SourceUnit getSourceUnit()

      Provides access to the SourceUnit for error reporting during visitation. Implementations must override this method.

      Returns:
        the source unit for this visitor

    - #### public void visitClass(ClassNode node)

      Visits a ClassNode, processing its annotations, package, imports, contents, and object initializers.

      Parameters:
        `node` - the class node to visit

    - #### public void visitConstructor(ConstructorNode node)

      Visits a ConstructorNode, processing its annotations, parameter annotations, and code block.

      Parameters:
        `node` - the constructor node to visit

    - #### public void visitDeclarationExpression(DeclarationExpression expression)

      Visits a DeclarationExpression with annotation processing, traversing expression annotations before delegating to parent traversal.

      Parameters:
        `expression` - the declaration expression to visit

    - #### public void visitField(FieldNode node)

      Visits a FieldNode, processing its annotations and initial value expression if present.

      Parameters:
        `node` - the field node to visit

    - #### public void visitMethod(MethodNode node)

      Visits a MethodNode, processing its annotations, parameter annotations, and code block.

      Parameters:
        `node` - the method node to visit

    - #### public void visitProperty(PropertyNode node)

      Visits a PropertyNode, processing its annotations, initial value expression, and getter/setter blocks if present.

      Parameters:
        `node` - the property node to visit